diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/libssh/server.c libssh-wfs/libssh/server.c
--- libssh-trunk/libssh/server.c	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/libssh/server.c	2009-07-14 19:23:51.000000000 -0400
@@ -221,7 +221,15 @@
     PUBLIC_KEY *pub;
     PRIVATE_KEY *prv;
     BUFFER *buf=buffer_new();
-    if(packet_wait(session, SSH2_MSG_KEXDH_INIT ,1))
+    int failed = pthread_mutex_lock(&session->packet_mutex);
+    assert(!failed);
+    int res;
+    pthread_cleanup_push(&ssh_cleanup_lock, (void *) &session->packet_mutex);
+    res = packet_wait(session, SSH2_MSG_KEXDH_INIT ,1);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->packet_mutex);
+    assert(!failed);
+    if(res)
         return -1;
     e=buffer_get_ssh_string(session->in_buffer);
     if(!e){
@@ -241,7 +249,7 @@
             prv=session->rsa_key;
             break;
         default:
-            prv=NULL;
+	    prv=NULL;
     }
     pub=publickey_from_privatekey(prv);
     pubkey=publickey_to_string(pub);
@@ -249,7 +257,11 @@
     dh_import_pubkey(session,pubkey);
     dh_build_k(session);
     make_sessionid(session);
-    sign=ssh_sign_session_id(session,prv);
+    if(prv != NULL){
+      sign=ssh_sign_session_id(session,prv);
+    } else {
+      sign=NULL;
+    }
     buffer_free(buf);
     /* free private keys as they should not be readable past this point */
     if(session->rsa_key){
@@ -260,18 +272,34 @@
         private_key_free(session->dsa_key);
         session->dsa_key=NULL;
     }
+    if(sign == NULL) {
+      free(f);
+      return -1;
+    }
+    failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH2_MSG_KEXDH_REPLY);
     buffer_add_ssh_string(session->out_buffer,pubkey);
     buffer_add_ssh_string(session->out_buffer,f);
     buffer_add_ssh_string(session->out_buffer,sign);
     free(sign);
-    packet_send(session);
+    packet_send(session); 
     free(f);
     buffer_add_u8(session->out_buffer,SSH2_MSG_NEWKEYS);
     packet_send(session);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
     ssh_say(2,"SSH_MSG_NEWKEYS sent\n");
-
+    failed = pthread_mutex_lock(&session->packet_mutex);
+    pthread_cleanup_push(&ssh_cleanup_lock, (void *) &session->packet_mutex);
+    assert(!failed);
     packet_wait(session,SSH2_MSG_NEWKEYS,1);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->packet_mutex);
+    assert(!failed);
     ssh_say(2,"Got SSH_MSG_NEWKEYS\n");
     generate_session_keys(session);
     /* once we got SSH2_MSG_NEWKEYS we can switch next_crypto and current_crypto */
@@ -301,3 +329,24 @@
 }
 /** @}
  */
+
+void ssh_send_issue_banner(SSH_SESSION *session, const char *banner) {
+  STRING *banner_s, *lang_s;
+  enter_function();
+  int failed = pthread_mutex_lock(&session->write_mutex);
+  assert(!failed);
+  pthread_cleanup_push(&ssh_cleanup_lock,
+		       (void *) &session->write_mutex);
+  buffer_add_u8(session->out_buffer,SSH2_MSG_USERAUTH_BANNER);
+  banner_s = string_from_char(banner);
+  buffer_add_ssh_string(session->out_buffer,banner_s);
+  string_free(banner_s);
+  lang_s = string_from_char("en");
+  buffer_add_ssh_string(session->out_buffer,lang_s);
+  string_free(lang_s);
+  packet_send(session);
+  pthread_cleanup_pop(0);
+  failed = pthread_mutex_unlock(&session->write_mutex);
+  assert(!failed);
+  leave_function();
+}
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/libssh/session.c libssh-wfs/libssh/session.c
--- libssh-trunk/libssh/session.c	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/libssh/session.c	2009-07-07 22:35:58.000000000 -0400
@@ -48,6 +48,16 @@
     session->log_indent=0;
     session->out_buffer=buffer_new();
     session->in_buffer=buffer_new();
+    int failed = pthread_mutex_init(&session->packet_mutex,NULL);
+    assert (!failed);
+    failed = pthread_mutex_init(&session->crypt_mutex,NULL);
+    assert (!failed);
+    failed = pthread_mutex_init(&session->write_mutex,NULL);
+    assert (!failed);
+    failed = pthread_mutex_init(&session->signal_mutex,NULL);
+    assert (!failed);
+    failed = pthread_cond_init(&session->signal_cond,NULL);
+    assert (!failed);
     return session;
 }
 
@@ -62,6 +72,10 @@
         buffer_free(session->in_buffer);
     if(session->out_buffer)
         buffer_free(session->out_buffer);
+    if(session->in_hashbuf)
+        buffer_free(session->in_hashbuf);
+    if(session->out_hashbuf)
+        buffer_free(session->out_hashbuf);
     if(session->banner)
         free(session->banner);
     if(session->options)
@@ -72,6 +86,8 @@
         crypto_free(session->next_crypto);
     if(session->socket)
     	ssh_socket_free(session->socket);
+    if(session->dh_server_signature)
+    	free(session->dh_server_signature);
     // delete all channels
     while(session->channels)
         channel_free(session->channels);
@@ -93,6 +109,16 @@
         ssh_message_free(session->ssh_message);
         free(session->ssh_message);
     }
+    int failed = pthread_mutex_destroy(&session->packet_mutex);
+    assert (!failed);
+    failed = pthread_mutex_destroy(&session->signal_mutex);
+    assert (!failed);
+    failed = pthread_mutex_destroy(&session->crypt_mutex);
+    assert (!failed);
+    failed = pthread_mutex_destroy(&session->write_mutex);
+    assert (!failed);
+    failed = pthread_cond_destroy(&session->signal_cond);
+    assert (!failed);
     memset(session,'X',sizeof(SSH_SESSION)); /* burn connection, it could hangs
                                                 sensitive datas */
     free(session);
@@ -177,13 +203,20 @@
             return r; // error or no data available
         }
         /* if an exception happened, it will be trapped by packet_read() */
+	int failed = pthread_mutex_lock(&session->packet_mutex);
+	assert(!failed);
+	pthread_cleanup_push(&ssh_cleanup_lock, (void *) &session->packet_mutex);
         if(packet_read(session)||packet_translate(session)){
-            leave_function();
-        	return -1;
+	  r=-1;
+	  goto exit;
         }
         packet_parse(session);
+	pthread_cleanup_pop(0);
+	failed = pthread_mutex_unlock(&session->packet_mutex);
+	assert(!failed);
         ++i;
     } while(r>0);
+ exit:
     leave_function();
     return r;
 }
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/libssh/sftp.c libssh-wfs/libssh/sftp.c
--- libssh-trunk/libssh/sftp.c	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/libssh/sftp.c	2009-07-07 22:35:58.000000000 -0400
@@ -44,7 +44,9 @@
     memset(sftp,0,sizeof(SFTP_SESSION));
     sftp->session=session;
     sftp->channel=channel_new(session);
-    if(channel_open_session(sftp->channel)){
+    ssh_cleanup_frame *frames[4];
+    bzero( frames, 4*sizeof(ssh_cleanup_frame *) );
+    if(channel_open_session(sftp->channel, frames)){
         channel_free(sftp->channel);
         free(sftp);
         leave_function();
@@ -142,7 +144,7 @@
     sftp_enter_function();
     packet->sftp=sftp;
     packet->payload=buffer_new();
-    if(channel_read(sftp->channel,packet->payload,4,0)<=0){
+    if(channel_read_nf(sftp->channel,packet->payload,4,0)<=0){
         buffer_free(packet->payload);
         free(packet);
         sftp_leave_function();
@@ -150,7 +152,7 @@
     }
     buffer_get_u32(packet->payload,&size);
     size=ntohl(size);
-    if(channel_read(sftp->channel,packet->payload,1,0)<=0){
+    if(channel_read_nf(sftp->channel,packet->payload,1,0)<=0){
         buffer_free(packet->payload);
         free(packet);
         sftp_leave_function();
@@ -158,7 +160,7 @@
     }
     buffer_get_u8(packet->payload,&packet->type);
     if(size>1)
-        if(channel_read(sftp->channel,packet->payload,size-1,0)<=0){
+        if(channel_read_nf(sftp->channel,packet->payload,size-1,0)<=0){
             buffer_free(packet->payload);
             free(packet);
             sftp_leave_function();
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/libssh/socket.c libssh-wfs/libssh/socket.c
--- libssh-trunk/libssh/socket.c	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/libssh/socket.c	2009-07-29 15:04:18.000000000 -0400
@@ -261,6 +261,7 @@
 		leave_function();
 		return ret;
 	}
+	if( buffer_get_rest(s->in_buffer) ) ;
 	memcpy(buffer,buffer_get_rest(s->in_buffer),len);
 	buffer_pass_bytes(s->in_buffer,len);
 	leave_function();
@@ -310,8 +311,10 @@
     }
     if(session->blocking){
         buf=malloc(to_read);
+	pthread_cleanup_push( &free, buf );
         r=ssh_socket_completeread(session->socket,buf,to_read);
-        if(r==SSH_ERROR || r ==0){
+	pthread_cleanup_pop(0);
+        if(r==SSH_ERROR || r < to_read){
             ssh_set_error(session,SSH_FATAL,
                 (r==0)?"Connection closed by remote host" : "Error reading socket");
             ssh_socket_close(session->socket);
@@ -433,6 +436,7 @@
     }
     fd->fd=s->fd;
     fd->events=0;
+    fd->revents=0;
     if(!s->data_to_read)
         fd->events |= POLLIN;
     if(!s->data_to_write)
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/libssh/string.c libssh-wfs/libssh/string.c
--- libssh-trunk/libssh/string.c	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/libssh/string.c	2009-07-09 21:09:40.000000000 -0400
@@ -79,6 +79,9 @@
     char *string=malloc(len);
     memcpy(string,str->string,len-1);
     string[len-1]=0;
+    if (strlen(string) != (len-1)) {
+      ssh_say(1, "warning: string_to_char STRING contains \\0!\n");
+    }
     return string;
 }
 
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/libssh/wrapper.c libssh-wfs/libssh/wrapper.c
--- libssh-trunk/libssh/wrapper.c	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/libssh/wrapper.c	2009-07-07 22:35:58.000000000 -0400
@@ -578,6 +578,12 @@
     server=session->server_kex.methods[SSH_HOSTKEYS];
     client=session->client_kex.methods[SSH_HOSTKEYS];
     match=ssh_find_matching(client,server);
+    if(!match) {
+        ssh_set_error(session,SSH_FATAL,"bad match in %s",server);
+        free(match);
+        leave_function();
+        return SSH_ERROR;
+    }
     if(!strcmp(match,"ssh-dss"))
         session->hostkeys=TYPE_DSS;
     else if(!strcmp(match,"ssh-rsa"))
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/Makefile.am libssh-wfs/Makefile.am
--- libssh-trunk/Makefile.am	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/Makefile.am	2009-07-09 21:09:39.000000000 -0400
@@ -2,7 +2,7 @@
 
 AM_CPPFLAGS = -I$(srcdir)/include
 
-LDADD = $(top_builddir)/libssh/libssh.la
+LDADD = $(top_builddir)/libssh/libssh.la -lrt
 
 noinst_PROGRAMS = samplesshd samplessh 
 
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/README.wfs libssh-wfs/README.wfs
--- libssh-trunk/README.wfs	1969-12-31 19:00:00.000000000 -0500
+++ libssh-wfs/README.wfs	2009-07-29 15:50:34.000000000 -0400
@@ -0,0 +1,12 @@
+This is a modified version of libssh, available at
+http://0xbadc0de.be/wiki/libssh:libssh, with some additons related to
+public-key authentication on the server.  Hopefully, those
+modifications will be merged upstream, but for now, you need to compile
+and install this seperately to use WheelFS with secure connections.
+
+This is based on libssh subversion revision number 198.
+
+diff -Naur --exclude "autom4te*" --exclude aclocal.m4 --exclude debian --exclude "config*" --exclude ".*" --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude "Doxyfile*" --exclude Makefile.Windows libssh-trunk libssh-wfs > /tmp/libssh-wfs.patch
+
+~Xavid and Jeremy
+
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/sample.c libssh-wfs/sample.c
--- libssh-trunk/sample.c	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/sample.c	2009-07-07 22:35:57.000000000 -0400
@@ -174,7 +174,7 @@
         }
         if(channels[0]){
             while(channel && channel_is_open(channel) && channel_poll(channel,0)){
-                lus=channel_read(channel,readbuf,0,0);
+                lus=channel_read_nf(channel,readbuf,0,0);
                 if(lus==-1){
                     ssh_say(0,"error reading channel : %s\n",ssh_get_error(session));
                     return;
@@ -187,7 +187,7 @@
                     write(1,buffer_get(readbuf),lus);
             }
             while(channel && channel_is_open(channel) && channel_poll(channel,1)){ /* stderr */
-                lus=channel_read(channel,readbuf,0,1);
+                lus=channel_read_nf(channel,readbuf,0,1);
                 if(lus==-1){
                     ssh_say(0,"error reading channel : %s\n",ssh_get_error(session));
                     return;
@@ -218,7 +218,9 @@
         tcgetattr(0,&terminal_local);
         memcpy(&terminal,&terminal_local,sizeof(struct termios));
     }
-    if(channel_open_session(channel)){
+    ssh_cleanup_frame *frames[4];
+    bzero( frames, 4*sizeof(ssh_cleanup_frame *) );
+    if(channel_open_session(channel, frames)){
         printf("error opening channel : %s\n",ssh_get_error(session));
         return;
     }
@@ -247,7 +249,9 @@
     for(i=0;i<MAXCMD && cmds[i];++i)
         s+=snprintf(buffer+s,sizeof(buffer)-s,"%s ",cmds[i]);
     channel=channel_new(session);
-    channel_open_session(channel);
+    ssh_cleanup_frame *frames[4];
+    bzero( frames, 4*sizeof(ssh_cleanup_frame *) );
+    channel_open_session(channel, frames);
     if(channel_request_exec(channel,buffer)){
         printf("error executing \"%s\" : %s\n",buffer,ssh_get_error(session));
         return;
@@ -390,7 +394,9 @@
     ssh_options_set_host(options,host);
     session=ssh_new();
     ssh_set_options(session,options);
-    if(ssh_connect(session)){
+    ssh_cleanup_frame *frames[4];
+    bzero( frames, 4*sizeof(ssh_cleanup_frame *) );
+    if(ssh_connect(session, frames)){
         fprintf(stderr,"Connection failed : %s\n",ssh_get_error(session));
         ssh_disconnect(session);
 	    ssh_finalize();
@@ -454,7 +460,7 @@
     printf("\n");
 
     /* no ? you should :) */
-    auth=ssh_userauth_autopubkey(session, NULL);
+    auth=ssh_userauth_autopubkey(session, NULL, frames);
     if(auth==SSH_AUTH_ERROR){
         fprintf(stderr,"Authenticating with pubkey: %s\n",ssh_get_error(session));
 	    ssh_finalize();
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/samplesshd.c libssh-wfs/samplesshd.c
--- libssh-trunk/samplesshd.c	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/samplesshd.c	2009-07-07 22:35:57.000000000 -0400
@@ -144,7 +144,7 @@
     printf("it works !\n");
     BUFFER *buf=buffer_new();
     do{
-        i=channel_read(chan,buf,0,0);
+        i=channel_read_nf(chan,buf,0,0);
         if(i>0)
             write(1,buffer_get(buf),buffer_get_len(buf));
     } while (i>0);
